/**
 * Created by xamidylin on 17.11.2014.
 */
'use strict';
(function (require, process) {
    var require;
    var fs = require('fs');
    var folderParam = "--folder=", baseParam = "--base=", cwdParam = "--cwd=";
    var folder = '';
    var base = ''
    var cwd = 'Modules'
    process.argv.forEach(function (val, index, array) {
        if (val.substr(0, folderParam.length) == folderParam) {
            folder = val.substr(folderParam.length);
        }
        if (val.substr(0, baseParam.length) == baseParam) {
            base = val.substr(baseParam.length);
        }
        if (val.substr(0, cwdParam.length) == cwdParam) {
            cwd = val.substr(cwdParam.length);
        }
    });
    var delimeter = /[\/\\]/g;
    var moduleName = folder.split(delimeter).pop();
    var moduleFullName = ((base ? base + '.' : '') + folder.split(delimeter).join('.')).replace(cwd + '.', '');

    function mkDir(){
        [].slice.call(arguments).forEach(function(dir){
            try {
                fs.mkdirSync(folder + "\\"+dir);
            } catch (e) {
            }
        });
    }
    mkDir("Directives",
        "Services",
        "Models",
        "Controllers",
        "Templates"
    );

    try {
        fs.writeFile(folder + '\\Module.ts',
            'module ' + moduleFullName + " {\n" +
            '\tvar module = angular.module(\'' + moduleFullName + '\',[]);\n' +
            "\texport var Module = module.name;\n" +
            '}');
    } catch (e) {
    }
    console.log(base, folder);

})(require, process);